import React, { FC } from 'react';
interface DataSource {
    id: number | string;
    label: string;
    code?: string;
    [key: string]: any;
    children?: Array<DataSource & {
        parentId?: number;
    }>;
}
interface Props {
    /**
     * @description 样式类名
     * @type string
     */
    className?: string;
    /**
     * @description 是否展示搜索框
     * @type boolean
     */
    hasSearch?: boolean;
    /**
     * @description 数据源
     * @type {
     *    id: number;
     *    label: string;
     *    code?: string;
     *    children?: Array<DataSource & { parentId: number }>;
     * }[]
     * @default []
     */
    dataSource: DataSource[];
    /**
     * @description 点击事件
     * @type (current: DataSource,item: DataSource[]) => void
     */
    onClick?: (current: DataSource, items: DataSource[]) => void;
}
declare const DataMenu: FC<Props> & {
    MenuFoldItem: React.FC<MenuFolderProps>;
};
interface MenuFolderProps {
    item: DataSource;
    levels: DataSource[];
    onClick?: (...arg: any[]) => void;
}
export default DataMenu;
export type { Props as DataMenuProps, DataSource };
