function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { Input } from 'antd';
import classNames from 'classnames';
import { map } from 'lodash';
import React, { useMemo, useState } from 'react';
import styles from "./index.module.scss";
var filterGroup = function filterGroup(group, searchVal) {
  var searchValMap = function searchValMap(item) {
    var _item$children;
    if (!(item !== null && item !== void 0 && (_item$children = item.children) !== null && _item$children !== void 0 && _item$children.length)) return item.label.includes(searchVal);
    return item.children.some(searchValMap);
  };
  return group.filter(function (item) {
    var _item$children2;
    return item.label.includes(searchVal) || ((_item$children2 = item.children) === null || _item$children2 === void 0 ? void 0 : _item$children2.some(searchValMap));
  });
};
var DataMenu = function DataMenu(props) {
  var className = props.className,
    _onClick = props.onClick,
    dataSource = props.dataSource,
    hasSearch = props.hasSearch;
  var _useState = useState(dataSource),
    _useState2 = _slicedToArray(_useState, 2),
    sourceList = _useState2[0],
    setSourceList = _useState2[1];
  var _useState3 = useState(new Set(dataSource.map(function (item) {
      return item.id;
    }))),
    _useState4 = _slicedToArray(_useState3, 2),
    openKeys = _useState4[0],
    setOpenKeys = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    searchInputValue = _useState6[0],
    setSearchInputValue = _useState6[1];
  if (dataSource !== sourceList) {
    setOpenKeys(new Set(dataSource.map(function (item) {
      return item.id;
    })));
    setSourceList(dataSource);
  }
  var toggleOpenKey = function toggleOpenKey(openKey) {
    if (openKeys.has(openKey)) {
      openKeys.delete(openKey);
    } else {
      openKeys.add(openKey);
    }
    setOpenKeys(new Set(openKeys));
  };
  var handleSearchInputChange = function handleSearchInputChange(e) {
    setSearchInputValue(e.target.value);
  };
  var filterSourceList = useMemo(function () {
    return filterGroup(sourceList, searchInputValue);
  }, [sourceList, searchInputValue]);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.block, className)
  }, !!hasSearch && /*#__PURE__*/React.createElement(Input, {
    maxLength: 30,
    className: styles.searchCtrl,
    value: searchInputValue,
    onChange: handleSearchInputChange,
    placeholder: '请输入数据名称'
  }), /*#__PURE__*/React.createElement("div", {
    className: styles.scrollBlock
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.listBox
  }, filterSourceList.map(function (group) {
    return /*#__PURE__*/React.createElement("div", {
      key: group.id,
      className: classNames(styles.listGroup, openKeys.has(group.id) && styles.open)
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.listGroupItem
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.groupLabel,
      onClick: function onClick() {
        return _onClick === null || _onClick === void 0 ? void 0 : _onClick(group, [group]);
      }
    }, group.label), /*#__PURE__*/React.createElement("div", {
      onClick: function onClick() {
        return toggleOpenKey(group.id);
      },
      className: classNames(styles.fold, openKeys.has(group.id) && styles.foldRotate)
    })), /*#__PURE__*/React.createElement("div", {
      className: styles.listGroupChildren
    }, map(group.children, function (item) {
      return /*#__PURE__*/React.createElement(DataMenu.MenuFoldItem, {
        item: item,
        levels: [group, item],
        onClick: _onClick
      });
    })));
  }))));
};
var MenuFoldItem = function MenuFoldItem(props) {
  var _item$children3, _item$children4;
  var item = props.item,
    levels = props.levels,
    _onClick2 = props.onClick;
  var _useState7 = useState(new Set()),
    _useState8 = _slicedToArray(_useState7, 2),
    openKey = _useState8[0],
    setOpenKey = _useState8[1];
  var toggleOpenKey = function toggleOpenKey(key) {
    if (openKey.has(key)) {
      openKey.delete(key);
    } else {
      openKey.add(key);
    }
    setOpenKey(new Set(openKey));
  };
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      alignItems: 'center'
    }
  }, /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      return toggleOpenKey(item.id);
    },
    className: classNames(!!(item !== null && item !== void 0 && (_item$children3 = item.children) !== null && _item$children3 !== void 0 && _item$children3.length) && styles.fold, openKey.has(item.id) && styles.foldRotate)
  }), /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.item, styles.supItem),
    key: item.id,
    onClick: function onClick() {
      _onClick2 === null || _onClick2 === void 0 ? void 0 : _onClick2(item, levels);
    }
  }, item.label)), /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.hidden, openKey.has(item.id) && styles.show)
  }, !!(item !== null && item !== void 0 && (_item$children4 = item.children) !== null && _item$children4 !== void 0 && _item$children4.length) ? map(item.children, function (item) {
    return /*#__PURE__*/React.createElement(DataMenu.MenuFoldItem, {
      key: item.id,
      item: item,
      levels: [].concat(_toConsumableArray(levels), [item]),
      onClick: _onClick2
    });
  }) : null));
};
DataMenu.MenuFoldItem = MenuFoldItem;
export default DataMenu;