function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { EditorView } from '@codemirror/view';
import CodeMirror from '@uiw/react-codemirror';
import React, { useEffect, useMemo, useRef, useState } from 'react';
import { operators, specialOperators } from "./config";
import styles from "./index.module.scss";
import { placeholders } from "./plugin";
import { formula } from "./utils";
function FormulaView(props) {
  var _props$value;
  var callback = props.callback,
    dataSource = props.dataSource,
    onPlaceholderClick = props.onPlaceholderClick,
    originMapData = props.mapData;
  var label = props === null || props === void 0 ? void 0 : (_props$value = props.value) === null || _props$value === void 0 ? void 0 : _props$value[0];
  var editor = useRef(null);
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    cursor = _useState2[0],
    setCursor = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    value = _useState4[0],
    setValue = _useState4[1];
  var mapData = useMemo(function () {
    if (!!originMapData) return originMapData;
    var map = {};
    dataSource.forEach(function (item) {
      var _item$children;
      (_item$children = item.children) === null || _item$children === void 0 ? void 0 : _item$children.forEach(function (child) {
        map["".concat(item.id, "_").concat(child.id)] = child.label;
      });
    });
    return map;
  }, [dataSource, originMapData]);
  var insertStr = function insertStr(str) {
    //@ts-ignore
    var specialCursor = specialOperators[str];
    var newCursor = cursor + (specialCursor || str).length;
    setValue(value.slice(0, cursor) + (specialCursor || str) + value.slice(cursor));
    setTimeout(function () {
      try {
        var _editor$current, _editor$current$view, _editor$current2, _editor$current2$view;
        (_editor$current = editor.current) === null || _editor$current === void 0 ? void 0 : (_editor$current$view = _editor$current.view) === null || _editor$current$view === void 0 ? void 0 : _editor$current$view.focus();
        (_editor$current2 = editor.current) === null || _editor$current2 === void 0 ? void 0 : (_editor$current2$view = _editor$current2.view) === null || _editor$current2$view === void 0 ? void 0 : _editor$current2$view.dispatch({
          selection: {
            anchor: newCursor
          }
        });
      } catch (e) {}
    }, 100);
  };
  useEffect(function () {
    if (callback) {
      callback(insertStr);
    }
  });
  useEffect(function () {
    var _props$onChange;
    var val = formula.toData(value);
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, [formula.toLabel(val, mapData), val]);
  }, [value, mapData]);
  useEffect(function () {
    if (label) {
      var _props$value$, _props$value2;
      var newValue = formula.toString((_props$value$ = (_props$value2 = props.value) === null || _props$value2 === void 0 ? void 0 : _props$value2[1]) !== null && _props$value$ !== void 0 ? _props$value$ : []);
      if (value !== newValue) {
        setValue(newValue);
        setTimeout(function () {
          try {
            var _editor$current3, _editor$current3$view;
            (_editor$current3 = editor.current) === null || _editor$current3 === void 0 ? void 0 : (_editor$current3$view = _editor$current3.view) === null || _editor$current3$view === void 0 ? void 0 : _editor$current3$view.dispatch({
              selection: {
                anchor: newValue.length
              }
            });
          } catch (e) {}
        }, 100);
      }
    }
  }, [label]);
  var handlePlaceholderClick = function handlePlaceholderClick(placeholderLabel, _, uniqueId) {
    var _placeholderLabel$spl, _placeholderLabel$spl2, _placeholderLabel$spl3, _placeholderLabel$spl4, _placeholderLabel$spl5, _placeholderLabel$spl6, _placeholderLabel$spl7, _placeholderLabel$spl8;
    var secondInfo = (_placeholderLabel$spl = placeholderLabel.split('@')) === null || _placeholderLabel$spl === void 0 ? void 0 : (_placeholderLabel$spl2 = _placeholderLabel$spl[1]) === null || _placeholderLabel$spl2 === void 0 ? void 0 : (_placeholderLabel$spl3 = _placeholderLabel$spl2.split('#')) === null || _placeholderLabel$spl3 === void 0 ? void 0 : _placeholderLabel$spl3[0];
    var otherInfo = (_placeholderLabel$spl4 = placeholderLabel.split('@')) === null || _placeholderLabel$spl4 === void 0 ? void 0 : (_placeholderLabel$spl5 = _placeholderLabel$spl4[1]) === null || _placeholderLabel$spl5 === void 0 ? void 0 : (_placeholderLabel$spl6 = _placeholderLabel$spl5.split('#')) === null || _placeholderLabel$spl6 === void 0 ? void 0 : _placeholderLabel$spl6[1];
    var codeList = (_placeholderLabel$spl7 = placeholderLabel.split('@')) === null || _placeholderLabel$spl7 === void 0 ? void 0 : (_placeholderLabel$spl8 = _placeholderLabel$spl7[0]) === null || _placeholderLabel$spl8 === void 0 ? void 0 : _placeholderLabel$spl8.split('_');
    var sourceList = [];
    codeList.forEach(function (key, index) {
      if (index === 0) {
        var source = dataSource.find(function (item) {
          return String(item.id) === String(key);
        });
        if (source) {
          sourceList.push(source);
        }
      } else {
        if (!!sourceList.length) {
          var _sourceList, _sourceList$children;
          var currentSource = (_sourceList = sourceList[sourceList.length - 1]) === null || _sourceList === void 0 ? void 0 : (_sourceList$children = _sourceList.children) === null || _sourceList$children === void 0 ? void 0 : _sourceList$children.find(function (item) {
            return String(item.id) === String(key);
          });
          if (currentSource) {
            sourceList.push(currentSource);
          }
        }
      }
    });
    var onChange = function onChange(secondInfo, otherInfo) {
      var _props$onChange2;
      var elements = document.querySelectorAll("[data-label=\"".concat(placeholderLabel, "\"]"));
      var elementCursor = Array.from(elements).findIndex(function (item) {
        return item.getAttribute('data-unique-id') === uniqueId;
      });
      var currentIndex = 0;
      var result = (value !== null && value !== void 0 ? value : '').replace(new RegExp(placeholderLabel, 'g'), function (match) {
        if (match === placeholderLabel) {
          currentIndex++;
          if (currentIndex === elementCursor + 1) {
            return "".concat(placeholderLabel.split('@')[0]).concat(secondInfo ? "@".concat(secondInfo) : '').concat(otherInfo ? "#".concat(otherInfo) : '');
          }
        }
        return match;
      });
      (_props$onChange2 = props.onChange) === null || _props$onChange2 === void 0 ? void 0 : _props$onChange2.call(props, [formula.toString(formula.toData(result)), formula.toData(result)]);
    };
    onPlaceholderClick === null || onPlaceholderClick === void 0 ? void 0 : onPlaceholderClick({
      secondInfo: secondInfo,
      otherInfo: otherInfo,
      sourceList: sourceList,
      onChange: onChange
    });
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: styles.container
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.operators
  }, operators.map(function (i) {
    return /*#__PURE__*/React.createElement("div", {
      key: i,
      className: styles.operator,
      onClick: function onClick() {
        return insertStr(i);
      }
    }, i);
  })), mapData && /*#__PURE__*/React.createElement(CodeMirror, {
    ref: editor,
    theme: "none",
    value: value,
    height: "160px",
    className: styles.editor,
    basicSetup: false,
    extensions: [placeholders(mapData, handlePlaceholderClick), EditorView.lineWrapping],
    onChange: function onChange(v) {
      return setValue(v);
    },
    onStatistics: function onStatistics(data) {
      setCursor(data.selectionAsSingle.from);
    }
  })));
}
export default FormulaView;