function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import { singleOperators } from "./config";
var isData = function isData(item) {
  return ['device', 'source', 'special_source'].includes(item.type);
};
var specialDispose = function specialDispose(item, callback) {
  var specialOperator = item.type === 'operator' && ['abs', 'sum'].includes(String(item.value) || '');
  if (specialOperator) {
    return "".concat(item.value, "(").concat(callback(), ")");
  }
  return item.value;
};
var getKey = function getKey(_ref) {
  var sourceCodeList = _ref.sourceCodeList,
    secondInfo = _ref.secondInfo,
    otherInfo = _ref.otherInfo;
  var idStr = (sourceCodeList === null || sourceCodeList === void 0 ? void 0 : sourceCodeList.reduce(function (pre, cur) {
    return "".concat(pre, "_").concat(cur);
  }, '').slice(1)) || '';
  return "".concat(idStr).concat(secondInfo ? "@".concat(secondInfo) : '').concat(otherInfo ? "#".concat(otherInfo) : '');
};
export var formula = {
  toString: function toString(data) {
    return data.reduce(function (pre, cur) {
      return "".concat(pre).concat(isData(cur) ? "[".concat(getKey(cur), "]") : specialDispose(cur, function () {
        var _cur$specialCalculati;
        return formula.toString((_cur$specialCalculati = cur.specialCalculationDTOList) !== null && _cur$specialCalculati !== void 0 ? _cur$specialCalculati : []);
      }));
    }, '');
  },
  toLabel: function toLabel(data, map) {
    return data.reduce(function (pre, cur) {
      return "".concat(pre).concat(isData(cur) ? map[getKey(cur)] || cur.value : specialDispose(cur, function () {
        var _cur$specialCalculati2;
        return formula.toLabel((_cur$specialCalculati2 = cur.specialCalculationDTOList) !== null && _cur$specialCalculati2 !== void 0 ? _cur$specialCalculati2 : [], map);
      }));
    }, '');
  },
  toStringByLabel: function toStringByLabel(str) {
    function deep(str) {
      if (str !== null && str !== void 0 && str.includes('sum(') || str !== null && str !== void 0 && str.includes('abs(')) {
        var subStart = str.indexOf('sum(');
        var absStart = str.indexOf('abs(');
        var start = subStart > absStart ? absStart >= 0 ? absStart : subStart : subStart >= 0 ? subStart : absStart;
        var end = str.indexOf(')', start) + 1;
        if (end <= 0) {
          return str.slice(0, start).split('');
        }
        return [].concat(_toConsumableArray(str.slice(0, start).split('')), [str.slice(start, end)], _toConsumableArray(deep(str.slice(end, str.length))));
      }
      return str.split('');
    }
    return deep(str);
  },
  toData: function toData(str) {
    var splitArr = formula.toStringByLabel(str);
    var data = [];
    var isField = false;
    var isNumber = false;
    var fieldStart = 0;
    var numberStart = 0;
    var lastIndex = ((splitArr === null || splitArr === void 0 ? void 0 : splitArr.length) || 0) - 1;
    var handleNumber = function handleNumber(index) {
      if (isNumber) {
        var number = splitArr.slice(numberStart, index).join('');
        data.push({
          type: 'number',
          value: number
        });
      }
    };
    splitArr.forEach(function (item, index) {
      switch (true) {
        case (item.includes('abs(') || item.includes('sum(')) && !isField:
          {
            handleNumber(index);
            isField = false;
            isNumber = false;
            data.push({
              type: 'operator',
              value: item.includes('abs(') ? 'abs' : 'sum',
              specialCalculationDTOList: formula.toData(item.slice(4, item.length - 1))
            });
            break;
          }
        case singleOperators.includes(item) && !isField:
          {
            handleNumber(index);
            isField = false;
            isNumber = false;
            data.push({
              type: 'operator',
              value: item
            });
            break;
          }
        case item === '[':
          {
            handleNumber(index);
            isField = true;
            isNumber = false;
            fieldStart = index;
            break;
          }
        case item === ']':
          {
            isField = false;
            isNumber = false;
            var field = splitArr.slice(fieldStart + 1, index).join('');
            var sourceCodeList = field.split('@')[0].split('_');
            var _sourceCodeList = _slicedToArray(sourceCodeList, 3),
              sourceId = _sourceCodeList[0],
              fieldId = _sourceCodeList[1],
              value = _sourceCodeList[2];
            var isSpecialData = field.includes('@');
            data.push({
              sourceId: sourceId,
              fieldId: fieldId,
              value: value,
              sourceCodeList: sourceCodeList,
              secondInfo: isSpecialData ? field.split('@')[1].split('#')[0] : undefined,
              otherInfo: isSpecialData ? field.split('@')[1].split('#')[1] : undefined,
              type: isSpecialData ? 'special_source' : value ? 'device' : 'source'
            });
            break;
          }
        default:
          {
            if (!isField) {
              if (!isNumber) {
                numberStart = index;
              }
              isNumber = true;
              if (index === lastIndex) {
                handleNumber(index + 1);
              }
            }
          }
      }
    });
    return data;
  }
};