import { PaginationData } from 'rc-pagination';
import { FC } from 'react';
interface Props {
    /**
     * @description 当前页
     * @type number
     * @default 1
     */
    current?: number;
    /**
     * @description 总条数
     * @type number
     */
    total: number;
    /**
     * @description 每页条数
     * @type number
     * @default 10
     */
    pageSize?: number;
    /**
     * @description 分页器ClassName
     * @type string
     */
    className?: string;
    /**
     * @description 每页条数选项
     * @type number[]
     */
    pageSizeOptions?: number[];
    /**
     * @description 每页条数改变回调
     * @type (current: number, size: string | number) => void
     */
    onChange?: (current: number, size: string | number) => void;
    /**
     * @description 分页器属性-详见 rc-pagination
     * @type Omit<PaginationData, 'current' | 'pageSize' | 'total' | 'showSizeChanger' | 'jumpPrevIcon' | 'jumpNextIcon'>
     */
    paginationProps?: Omit<PaginationData, 'current' | 'pageSize' | 'total' | 'showSizeChanger' | 'jumpPrevIcon' | 'jumpNextIcon'>;
}
declare const Pagination: FC<Props>;
export default Pagination;
export type { Props as PaginationProps };
