function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import cn from 'classnames';
import RcPagination from 'rc-pagination';
import React from 'react';
import styles from "./index.module.scss";
var Pagination = function Pagination(props) {
  var _props$current = props.current,
    current = _props$current === void 0 ? 1 : _props$current,
    total = props.total,
    _props$pageSize = props.pageSize,
    pageSize = _props$pageSize === void 0 ? 10 : _props$pageSize,
    className = props.className,
    _props$pageSizeOption = props.pageSizeOptions,
    pageSizeOptions = _props$pageSizeOption === void 0 ? [10, 20, 50, 100] : _props$pageSizeOption,
    _onChange = props.onChange,
    paginationProps = props.paginationProps;
  var totalPage = Math.ceil(total / pageSize);
  return /*#__PURE__*/React.createElement("div", {
    className: cn(styles.pagination, className)
  }, /*#__PURE__*/React.createElement("div", null, "\u6BCF\u9875\u663E\u793A ", pageSize, " \u6761\uFF0C\u5171 ", totalPage, " \u9875\uFF0C\u5F53\u524D", ' ', "".concat(current, "/").concat(totalPage)), /*#__PURE__*/React.createElement("div", {
    className: styles.right
  }, /*#__PURE__*/React.createElement(RcPagination, _extends({
    current: current,
    pageSize: pageSize,
    total: total,
    showSizeChanger: false,
    jumpPrevIcon: function jumpPrevIcon() {
      return /*#__PURE__*/React.createElement("span", null, "...");
    },
    jumpNextIcon: function jumpNextIcon() {
      return /*#__PURE__*/React.createElement("span", null, "...");
    },
    onChange: _onChange
  }, paginationProps)), "\u6BCF\u9875\u663E\u793A", _onChange ? /*#__PURE__*/React.createElement("select", {
    className: cn(styles.select, 'select'),
    value: pageSize,
    onChange: function onChange(e) {
      return _onChange === null || _onChange === void 0 ? void 0 : _onChange(1, e.target.value);
    }
  }, pageSizeOptions.map(function (option) {
    return /*#__PURE__*/React.createElement("option", {
      key: option,
      value: option
    }, option);
  })) : pageSize, "\u6761\u8BB0\u5F55"));
};
export default Pagination;