import { ButtonProps } from "../Button";
import { UsePaginationOptions } from "../hooks/usePagination";
import { TableProps } from 'rc-table';
import React, { ReactNode, type FC } from 'react';
interface Props {
    /**
     * @description 样式
     * @type React.CSSProperties
     */
    style?: React.CSSProperties;
    /**
     * @description 类名
     * @type string
     */
    className?: string;
    /**
     * @description 表格类名
     * @type string
     */
    tableClassName?: string;
    /**
     * @description 额外内容
     * @type ReactNode
     */
    extra?: ReactNode;
    /**
     * @description 表格底部
     * @type ReactNode
     */
    footer?: ReactNode;
    /**
     * @description 表格属性-参考：rc-table
     * @type TableProps
     */
    tableProps?: Omit<TableProps<Record<string, any>>, 'data' | 'columns'>;
    /**
     * @description 按钮属性-参考：Button组件属性
     * @type ButtonProps
     */
    btnProps?: ButtonProps;
    /**
     * @description 列属性-参考：rc-table
     * @type TableProps['columns']
     */
    columns: TableProps<any>['columns'];
    /**
     * @description 请求信息配置-参考：usePagination属性
     * @type UsePaginationOptions
     */
    requestInfo: UsePaginationOptions;
}
declare const TablePage: FC<Props>;
export default TablePage;
export type { Props as TablePageProps };
