import { FC } from 'react';
interface Options {
    /**
     * @description 默认每页条数
     * @type number
     * @default 10
     */
    defaultPageSize?: number;
    /**
     * @description 默认当前页
     * @type number
     * @default 1
     */
    defaultCurrent?: number;
    /**
     * @description 请求接口回调
     * @type (params: any) => Promise<{
     *  current: number;
     *  pageSize: number;
     *  total: number;
     *  data: any[];
     * }>
     */
    apiCallback: (params: any) => Promise<{
        current: number;
        pageSize: number;
        total: number;
        data: any[];
    }>;
    /**
     * @description 请求接口异常处理回调
     * @type (error: any) => void
     */
    errorCallback?: (error: any) => void;
}
export declare function usePagination<T = any>(options: Options): {
    isLoading: boolean;
    current: number;
    pageSize: number;
    total: number;
    dataSource: T[];
    fetch: (params?: {}) => Promise<void>;
};
declare const Index: FC<Options>;
export default Index;
export { Options as UsePaginationOptions };
